package volume;

import java.awt.*;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.applet.*;
import java.text.DecimalFormat;
import java.util.Hashtable;
import java.util.Enumeration;


public class Volume extends Applet implements AdjustmentListener, ItemListener {

protected Image graph;
protected Graphics g;
protected GraphCanvas graphC;
protected Scrollbar choixRayon;
protected Label resultTexte, messRayon, messUnite;
protected double rayon = 0.0;
protected double volume;
protected static String typeUnite = " " + Messages.get("metres");
protected static String typeVolume = "";
protected Hashtable uniteVol = new Hashtable();
protected Hashtable abrevVol = new Hashtable();
protected Choice choixUnite;
protected Image equation = Toolkit.getDefaultToolkit().getImage(Volume.class.getResource("equation.gif"));
protected Image sphere = Toolkit.getDefaultToolkit().getImage(Volume.class.getResource("sphere.gif"));
protected DecimalFormat df1 = new DecimalFormat("#######0.0");
protected DecimalFormat df2 = new DecimalFormat("#######0.00");
protected DecimalFormat df3 = new DecimalFormat("#######0.000");


public void init() 
{
	 chargementImage();
	 setBackground(new Color(123, 125, 173));
	 setFont(new Font(getFont().getName(), 0, 11));
     uniteVol.put(" " + Messages.get("millimetres"), Messages.get("millimetres_cube"));
     uniteVol.put(" " + Messages.get("metres"), Messages.get("metres_cube"));
     uniteVol.put(" " + Messages.get("kilometres"), Messages.get("kilometres_cube"));
     uniteVol.put(" " + Messages.get("parsecs"), Messages.get("parsecs_cube"));
     abrevVol.put(" " + Messages.get("millimetres"), Messages.get("mm"));
     abrevVol.put(" " + Messages.get("metres"), Messages.get("m"));
     abrevVol.put(" " + Messages.get("kilometres"), Messages.get("km"));
     abrevVol.put(" " + Messages.get("parsecs"), Messages.get("pc"));
     // Graph
     Panel graphPanel = new Panel(new BorderLayout());
     graphC = new GraphCanvas(290, 210);
     graph = createImage(290, 210);
     g = graph.getGraphics();
     // Text
     Panel textPanel = new Panel(new GridBagLayout());
     GridBagConstraints c = new GridBagConstraints();
     c.gridwidth = 1;
     c.gridx = 0;
     c.gridy = 0;
     c.ipady = 5;
     c.anchor = GridBagConstraints.EAST;
     messUnite = new Label();
     messUnite.setForeground(Color.white);
     messUnite.setText(" " + Messages.get("Changer_unite") + " :");
     textPanel.add(messUnite, c);
     c.gridwidth = 2;
     c.gridx = 1;
     c.anchor = GridBagConstraints.WEST;
     choixUnite = new Choice();
     choixUnite.add(" " + Messages.get("millimetres"));
     choixUnite.add(" " + Messages.get("metres"));
     choixUnite.add(" " + Messages.get("kilometres"));
     choixUnite.add(" " + Messages.get("parsecs"));
     choixUnite.select(typeUnite);
     choixUnite.addItemListener(this);
     textPanel.add(choixUnite, c);
     c.gridwidth = 1;
     c.gridx = 0;
     c.gridy = 1;
     c.anchor = GridBagConstraints.EAST;
     messRayon = new Label();
     messRayon.setForeground(Color.white);
     messRayon.setText(Messages.get("Modifier_rayon") + " :");
     textPanel.add(messRayon, c);     
     c.weightx = 2.0;
     c.gridx = 1;
     c.fill = GridBagConstraints.HORIZONTAL;     
     choixRayon = new Scrollbar(Scrollbar.HORIZONTAL, 0, 2, 0, 52);
     choixRayon.addAdjustmentListener(this);
     choixRayon.setValue(0);
     textPanel.add(choixRayon, c);
     c.gridwidth = 3;
     c.gridx = 0;
     c.gridy = 2;
     volume = (((4.0/3.0)*Math.PI)*Math.pow(rayon,3));
     resultTexte = new Label();
     resultTexte.setAlignment(1);
     resultTexte.setForeground(Color.white);
     resultTexte.setText(" " + Messages.get("Pour_r") + " = " + df1.format(rayon) + " " + abrevVol.get(typeUnite) + " : " + Messages.get("V_r") + " = " + df2.format(volume) + " " + uniteVol.get(typeUnite));
     textPanel.add(resultTexte, c);
     graphPanel.add(graphC, BorderLayout.CENTER);
     graphPanel.add(textPanel, BorderLayout.SOUTH);
     add(graphPanel);
     majGraph();
     validate();
}


protected void chargementImage() 
{
     MediaTracker tracker = new MediaTracker(this);
     tracker.addImage(equation, 0);
     tracker.addImage(sphere, 1);
     try { tracker.waitForAll(); } 
     catch (InterruptedException e) { }
}
 
 
public void itemStateChanged(ItemEvent itemevent)
{
     if(itemevent.getSource() == choixUnite)
     {
          typeUnite = choixUnite.getSelectedItem(); 
          resultTexte.setText(" " + Messages.get("Pour_r") + " = " + df1.format(rayon) + " " + abrevVol.get(typeUnite) + " : " + Messages.get("V_r") + " = " + df2.format(volume) + " " + uniteVol.get(typeUnite));
          majGraph();
     }
}
 
 
public void adjustmentValueChanged(AdjustmentEvent adjustmentevent)
{
     java.awt.Adjustable adjustable = adjustmentevent.getAdjustable();
     if(adjustable == choixRayon)
     {
          rayon = (double)((adjustmentevent.getValue())/10.0);
          volume = (((4.0/3.0)*Math.PI)*(Math.pow(rayon,3)));
          resultTexte.setText(" " + Messages.get("Pour_r") + " = " + df1.format(rayon) + " " + abrevVol.get(typeUnite) + " : " + Messages.get("V_r") + " = " + df2.format(volume) + " " + uniteVol.get(typeUnite));
          majGraph();
     }
}


protected void majGraph()
{
     g.setFont(new Font(getFont().getName(), 1, 11));
     g.setColor(new Color(229,229,239));
     g.fillRect(0, 0, 290, 210);  
     g.drawImage(sphere, 126 - (int)(13 * rayon) , 40, (int)(20 * rayon), (int)(20 * rayon), this);
     g.drawImage(equation, 175, 95, this);
     g.setColor(Color.gray);
     g.drawLine(50, 17, 50, 190);
     g.drawLine(50, 190, 280, 190);
     g.drawLine(50, 17, 48, 21);
     g.drawLine(50, 17, 52, 21);
     g.drawLine(280, 190, 276, 188);
     g.drawLine(280, 190, 276, 192);
     g.drawString(Messages.get("Rayon") + " (" + abrevVol.get(typeUnite) + ")" , 220, 205);	    
     g.drawString(Messages.get("Volume") + " (" + abrevVol.get(typeUnite) + "  )", 7, 13);
     FontMetrics fm = getFontMetrics(new Font(getFont().getName(), 1, 11));
     int deplacement = fm.stringWidth((String)(Messages.get("Volume") + " (" + abrevVol.get(typeUnite)));
     g.setFont(new Font(getFont().getName(), 0, 7));
     g.drawString("3", 7 + deplacement , 8);
     g.setFont(new Font(getFont().getName(), 1, 11));
     g.setColor(Color.black);
     int x = 50;
     int y = 190;
     for (int i=0; i<=157; i++) {
          double thisVolume = (((4.0/3.0)*Math.PI)*Math.pow(((double)i/30),3));
          g.drawLine(x, y, 50+i, 190 - (int)(Math.round(thisVolume/3.2)));
          x = 50 + i;
          y = 190 - (int)(Math.round(thisVolume/3.2));
     }
     g.setColor(new Color(190,190,210));
     g.drawLine(50 + (int)(30*rayon), 190, 50 + (int)(30*rayon), 190 - (int)(Math.round(volume/3.2)));
     g.drawLine(50 , 190 - (int)(Math.round(volume/3.2)), 50 + (int)(30*rayon) , 190 - (int)(Math.round(volume/3.2)));
     g.setColor(Color.red);
     g.drawLine(48 + (int)(30*rayon) , 188 - (int)(Math.round(volume/3.2)) , 52 + (int)(30*rayon), 192 - (int)(Math.round(volume/3.2)));
     g.drawLine(48 + (int)(30*rayon) , 192 - (int)(Math.round(volume/3.2)), 52 + (int)(30*rayon), 188 - (int)(Math.round(volume/3.2)));
     g.drawString(df1.format(rayon), 43 + (int)(30*rayon), 205); 
     g.drawString(df3.format(volume), 7, 194 - (int)(Math.round(volume/3.2)));
     graphC.updateImage(graph);
}


public void destroy()
{  
	g.dispose();
	sphere.flush();
	equation.flush();
}

}